
library IEEE;
   use IEEE.std_logic_1164.all;
   USE ieee.std_logic_arith.all ;
   USE ieee.std_logic_unsigned.all ;

LIBRARY std;
    USE std.textio.all;
	 
library altera_mf;
use altera_mf.altera_mf_components.all;

entity DSMC_LAB_DEMO is

      --//=======================================================
--//  PORT declarations
--//=======================================================

   PORT (

--	//////////// CLOCK //////////
	CLOCK_50 		: IN STD_LOGIC;

--	//////////// LED //////////
	LED			:OUT STD_LOGIC_VECTOR(7 downto 0);

--	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO_0			:INOUT STD_LOGIC_VECTOR(33 downto 0);
	--GPIO_0_0TO13			:IN STD_LOGIC_VECTOR(13 downto 0);
	--GPIO_0_14TO33			:OUT STD_LOGIC_VECTOR(33 downto 14);
	GPIO_0_IN 		:IN STD_LOGIC_VECTOR(1 downto 0);
--	//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
	GPIO_1			:INOUT STD_LOGIC_VECTOR(33 downto 0);
	GPIO_1_IN		:IN STD_LOGIC_VECTOR(1 downto 0)
);

end DSMC_LAB_DEMO ;

architecture rtl of DSMC_LAB_DEMO is

signal led_s : STD_LOGIC_VECTOR(7 downto 0);
signal inp7 : STD_LOGIC_VECTOR(3 downto 0);
signal cnt : STD_LOGIC_VECTOR(19 downto 0);
signal outpSRV, clki, rst : STD_LOGIC ;

begin
clki <= CLOCK_50;
inp7 <= GPIO_0(3 downto 0);
rst <= GPIO_0(13);

process (clki, rst)	-- CYCLE
begin
-- Servo Frequency: 50 Hz <=> 20msec
-- Pulse width: 
-- 	1ms = all the way one direction, 
-- 	1.5ms = center range, 
-- 	2.1ms = all the way the other direction.

if (rst='1') then
   cnt <= (others=>'0');
	outpSRV<='0';
elsif (clki'event and clki = '1') then
		--if (cntlow=selpins) then
		if (cnt=75500) then	-- @1.5msec
			outpSRV<='0';
	   		cnt <= cnt + 1;
		elsif (cnt=1000000) then 	-- @20msec
			outpSRV<='1';
			cnt<=(others=>'0');
		else
			outpSRV <= outpSRV;
			cnt <= cnt + 1;
		end if;
end if;
end process;
GPIO_0(25) <= outpSRV;

end rtl ;

